/*
CVE Services API

The CVE Services API supports automation tooling for the CVE Program. Credentials are     required for most service endpoints. Representatives of     <a href='https://www.cve.org/ProgramOrganization/CNAs'>CVE Numbering Authorities (CNAs)</a> should     use one of the methods below to obtain credentials:    <ul><li>If your organization already has an Organizational Administrator (OA) account for the CVE     Services, ask your admin for credentials</li>     <li>Contact your Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/Google'>Google</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/INCIBE'>INCIBE</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/jpcert'>JPCERT/CC</a>, or     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/redhat'>Red Hat</a>) or     Top-Level Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/icscert'>CISA ICS</a>     or <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/mitre'>MITRE</a>) to request credentials     </ul>     <p>CVE data is to be in the JSON 5.0 CVE Record format. Details of the JSON 5.0 schema are     located <a href='https://github.com/CVEProject/cve-schema/tree/master/schema/v5.0' target='_blank'>here</a>.</p>    <a href='https://cveform.mitre.org/' class='link' target='_blank'>Contact the CVE Services team</a>

API version: 2.1.4
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package cveapi

import (
	"encoding/json"
)

// checks if the CreateCveIdsResponseMeta type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CreateCveIdsResponseMeta{}

// CreateCveIdsResponseMeta struct for CreateCveIdsResponseMeta
type CreateCveIdsResponseMeta struct {
	RemainingQuota *int32 `json:"remaining_quota,omitempty"`
}

// NewCreateCveIdsResponseMeta instantiates a new CreateCveIdsResponseMeta object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateCveIdsResponseMeta() *CreateCveIdsResponseMeta {
	this := CreateCveIdsResponseMeta{}
	return &this
}

// NewCreateCveIdsResponseMetaWithDefaults instantiates a new CreateCveIdsResponseMeta object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateCveIdsResponseMetaWithDefaults() *CreateCveIdsResponseMeta {
	this := CreateCveIdsResponseMeta{}
	return &this
}

// GetRemainingQuota returns the RemainingQuota field value if set, zero value otherwise.
func (o *CreateCveIdsResponseMeta) GetRemainingQuota() int32 {
	if o == nil || IsNil(o.RemainingQuota) {
		var ret int32
		return ret
	}
	return *o.RemainingQuota
}

// GetRemainingQuotaOk returns a tuple with the RemainingQuota field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateCveIdsResponseMeta) GetRemainingQuotaOk() (*int32, bool) {
	if o == nil || IsNil(o.RemainingQuota) {
		return nil, false
	}
	return o.RemainingQuota, true
}

// HasRemainingQuota returns a boolean if a field has been set.
func (o *CreateCveIdsResponseMeta) HasRemainingQuota() bool {
	if o != nil && !IsNil(o.RemainingQuota) {
		return true
	}

	return false
}

// SetRemainingQuota gets a reference to the given int32 and assigns it to the RemainingQuota field.
func (o *CreateCveIdsResponseMeta) SetRemainingQuota(v int32) {
	o.RemainingQuota = &v
}

func (o CreateCveIdsResponseMeta) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CreateCveIdsResponseMeta) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.RemainingQuota) {
		toSerialize["remaining_quota"] = o.RemainingQuota
	}
	return toSerialize, nil
}

type NullableCreateCveIdsResponseMeta struct {
	value *CreateCveIdsResponseMeta
	isSet bool
}

func (v NullableCreateCveIdsResponseMeta) Get() *CreateCveIdsResponseMeta {
	return v.value
}

func (v *NullableCreateCveIdsResponseMeta) Set(val *CreateCveIdsResponseMeta) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateCveIdsResponseMeta) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateCveIdsResponseMeta) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateCveIdsResponseMeta(val *CreateCveIdsResponseMeta) *NullableCreateCveIdsResponseMeta {
	return &NullableCreateCveIdsResponseMeta{value: val, isSet: true}
}

func (v NullableCreateCveIdsResponseMeta) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateCveIdsResponseMeta) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


